// ------------------------------------------------------------------------------
// -------------- controllerAbout
// ------------------------------------------------------------------------------

angular.module('clearreportsApp').controller("controllerAbout", function ($scope, $compile, $interval, $timeout, $rootScope, userservice, $sce) {

    $scope.userservice = userservice;
    
    $scope.serverversion = $('html').attr('version');
    $scope.userid = $('meta[name="current-user"]').attr('content');
    var lang = $('html').attr('lang');
    console.log("asd");
    $scope.disclaimer = function () {
        var message = Util.getHtmlEncoded( $rootScope.getMsg('disclaimer').replace(/<br\s*\/?>/mg,"\n") ).replace(/\n/mg, "<br>")
        return $sce.trustAsHtml(message);
    };
    
    
    var browserLanguage = navigator.language;
    if (browserLanguage.indexOf('-')>0) {
        browserLanguage = browserLanguage.substring(0,browserLanguage.indexOf('-'));
    }
    var valBrowser = ($rootScope.getMsg('locale.' + browserLanguage)[0] == '{' ? browserLanguage : $rootScope.getMsg('locale.' + browserLanguage) );
    var valUser = ($rootScope.getMsg('locale.' + lang)[0] == '{' ? lang : $rootScope.getMsg('locale.' + lang));

    $scope.navigatorInfo = [];
    $scope.navigatorInfo.push({key: $rootScope.getMsg('user.name'), value: (userservice.userCache[$scope.userid] == undefined ? "" : userservice.userCache[$scope.userid].displayName) + " (ID "+$scope.userid+")" });
    $scope.navigatorInfo.push({key: $rootScope.getMsg('navigator.language') + " / " + $rootScope.getMsg('user.language'), value: valBrowser + " / " + valUser});
    $scope.navigatorInfo.push({key: $rootScope.getMsg('navigator.userAgent'), value: navigator.userAgent});
    $scope.navigatorInfo.push({key: $rootScope.getMsg('document.defaultCharset'), value: document.characterSet ? document.characterSet : document.charset});
    $scope.navigatorInfo.push({key: $rootScope.getMsg('screen.size') + " / " + $rootScope.getMsg('screen.current'), value: screen.width + "x" + screen.height + " / " + $(window).width() + "x" + $(window).height()});
    $scope.navigatorInfo.push({key: $rootScope.getMsg('screen.colorDepth'), value: screen.colorDepth + " bit"});
    $scope.navigatorInfo.push({key: $rootScope.getMsg('navigator.cookieEnabled'), value: $rootScope.getMsg('cookie' + navigator.cookieEnabled)});

    $scope.timeModel = {};
    
    $scope.$watch('userservice.userCache[userid]', function() {
        var usernameEntry = {key: $rootScope.getMsg('user.name'), value: (userservice.userCache[$scope.userid] == undefined ? "" : userservice.userCache[$scope.userid].displayName) + " (ID "+$scope.userid+")" };
        $scope.navigatorInfo.splice(0,1,usernameEntry);
    });

    var intervalHandle = null;

    var calculateTimeRunning = function () {
        $scope.timeModel.endTime = new Date().getTime();
        var diff = $scope.timeModel.endTime - $rootScope.loaded;
        $scope.timeModel.days = Math.floor(diff / 86400000);
        diff -= $scope.timeModel.days * 86400000;
        $scope.timeModel.hours = Math.floor(diff / 3600000);
        diff -= $scope.timeModel.hours * 3600000;
        $scope.timeModel.minutes = Math.floor(diff / 60000);
        diff -= $scope.timeModel.minutes * 60000;
        $scope.timeModel.seconds = Math.floor(diff / 1000);

    };

    intervalHandle = $interval(calculateTimeRunning, 1000);
    $timeout(calculateTimeRunning);
    
});